/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 */

#include "level_func.h"

gboolean NOT_END(Level* level)
{
    return TRUE;
}

void setField(Level* level,guint32 field,guint32 typ)
{
	g_assert(field<level->map.columns*level->map.raws);
	level->map.field[field]=typ;
}

void setParx(Level* level,guint32 field,guint32 typ)
{
	g_assert(field<level->map.columns*level->map.raws);
	level->map.parx[field]=typ;
}

void setPary(Level* level,guint32 field,guint32 typ)
{
	g_assert(field<level->map.columns*level->map.raws);
	level->map.pary[field]=typ;
}


gboolean is_bal_in_squere(Level* level,guint x1,guint y1,guint x2,guint y2)
{
    GList* list;
    Balaban* balaban;
    
    list=level->balabans;
    while(list){
        balaban=(Balaban*)list->data;
        list=list->next;
        if(balaban->column>=x1 && balaban->column<=x2 &&
            balaban->raw>=y1 && balaban->raw<=y2) return TRUE;
    }
    return FALSE;    
}    

gint COUNT_SHOTS(Level* level)
{
    gint pocetNab=level->player.projectiles;
    gint i;
    
    for(i=0;i<level->map.raws*level->map.columns;i++){
        if(level->map.field[i]==3)pocetNab+=5;
    }    
   
    return pocetNab;
}

gboolean COUNT_END(Level* level)
{
	gint pocet3= get_pocet_3bab(level);
    gint pocet2= get_pocet_2bab(level);
    gint pocet=0;
    gint pocetMin=level->player.mines;
    gint pocetNab=level->player.projectiles;
    gint i;
    
    for(i=0;i<level->map.raws*level->map.columns;i++){
        if(level->map.field[i]==3)pocetNab+=5;
        if(level->map.field[i]==5)pocetMin+=5;
        if(IS_MINE(level->map.field[i])) pocetMin++;
    }    
    
    if(level->balabans) pocet=g_list_length(level->balabans);
    if(pocetMin>pocet3){
        pocet-=pocet3;
		pocetMin-=pocet3;
    }else{
		pocet+=2*pocet3-3*pocetMin;
		pocetMin=0;
	}
    if(pocetMin>pocet2)
        pocet-=pocetMin;
    else
        pocet+=pocet2-2*pocetMin;    
    return pocetNab>=pocet;
}

gint COUNT_END_POCET(Level* level)
{
	gint pocet3= get_pocet_3bab(level);
    gint pocet2= get_pocet_2bab(level);
    gint pocet=0;
    gint pocetMin=level->player.mines;
    gint pocetNab=level->player.projectiles;
    gint i;
    
    for(i=0;i<level->map.raws*level->map.columns;i++){
        if(level->map.field[i]==3)pocetNab+=5;
        if(level->map.field[i]==5)pocetMin+=5;
        if(IS_MINE(level->map.field[i])) pocetMin++;
    }    
    
    if(level->balabans) pocet=g_list_length(level->balabans);
    if(pocetMin>pocet3){
        pocet-=pocet3;
		pocetMin-=pocet3;
    }else{
		pocet+=2*pocet3-3*pocetMin;
		pocetMin=0;
	}
    if(pocetMin>pocet2)
        pocet-=pocetMin;
    else
        pocet+=pocet2-2*pocetMin;    
     return pocetNab-pocet;
}

// Fuel musí být samostatně a nic jiného než střela nemůže spustit výbuch
gint COUNT_END_1_FUEL(Level* level)
{
	gint pocet=COUNT_END_POCET(level);
    gint pocetF=0;
    gint pocetNab=level->player.projectiles;
    gint i;
    
    for(i=0;i<level->map.raws*level->map.columns;i++){
        if(level->map.field[i]==6)pocetF++;
        if(level->map.field[i]==3)pocetNab+=5;
    }    
    
     if(pocetNab<pocetF) pocetF=pocetNab;
   
     return (pocet+6*pocetF)>=0;
}


Balaban* alloc_balaban(guint32 col,guint32 raw,guint32 type,GList** list)
{
    gint i;
    Balaban* balaban=(Balaban*)g_malloc(sizeof(Balaban));
    balaban->column=col; 
    balaban->raw=raw;
    balaban->type=type;
	switch(balaban->type){
		case 0:
		case 2:
		case 3:
			balaban->moves=2;
			break;
		case 1:
	        balaban->moves=1;
			break;
		case 4:
	        balaban->moves=0;
			break;
	}
    for(i=0;i<16;i++) balaban->param[i]=0;
    *list=g_list_append(*list,(gpointer)balaban);
    return balaban;
}

void set_map(Map* map,guint32 col,guint32 raw)
{
    gint i,j;
    
    map->columns=col;
    map->raws=raw;
    map->field=(guint32*)g_malloc(map->columns*map->raws*sizeof(guint32));
    map->parx=(guint32*)g_malloc(map->columns*map->raws*sizeof(guint32));
    map->pary=(guint32*)g_malloc(map->columns*map->raws*sizeof(guint32));
    for(i=0;i<raw;i++){
        for(j=0;j<col;j++){
            map->field[i*col+j]=0;
            map->parx[i*col+j]=0;
            map->pary[i*col+j]=0;
        }
    }
}

void set_player(Player* player,guint32 col,guint32 raw,guint32 project,guint32 mine)
{
    player->column=col;    
    player->raw=raw;
    player->orientation=0;
    player->projectiles=project;
    player->mines=mine;
    player->moves=5;
    player->shots=5;
    player->pulls_moves=0;
    player->pulls_shots=0;
}       

